#include <sys/types.h>
#include <sys/stat.h>

static const unfs3_fh_t invalid_fh = {.dev = 0,.ino = 0,.gen = 0,.len = 0,.inos = {0}};
/*
 * hash function for inode numbers
 */
#define FH_HASH(n)      ((n + 3 * (n >> 8) + 5 * (n >> 16)) & 0xFF)
	
       
/* This is used for supporting deleted files 
   Needs support from inode on disk struct
*/
int getInodeGen()
{
	return (0); 
}
/* Cache options */
/* This shall be overwritten when
checking for a password which we have 
ignored as of now ! */
uint32 export_password_hash = 0;

/*
 * compose a filehandle for a given path
 * path:     path to compose fh for
 * need_dir: if not 0, path must point to a directory
 Right now not doing anything for removable devices
 */ 
unfs3_fh_t fh_comp_raw(const char *path)
{
	int result;
	struct stat buff;	
	char *last;
	char work[NFS_MAXPATHLEN];
	result = lstat(path, &buff);
	if(result == -1)
	{
		return invalid_fh; 
	} 
	if(buff.st_mode & S_IFDIR != S_IFDIR) 
	{
		return invalid_fh; 
	}
	fh.dev = buff.st_dev;
	fh.ino = buff.st_ino;
	fh.gen = getInodeGen();  /* check how this is to be done */
	if(strcmp(path,"/")==0)
	{
		return fh;
	}
	strcpy(work, path);
	last = work;
        do
	{
        	*last = '/';
	        last = strchr(last + 1, '/');
        	if (last != NULL)	
		{
           		 *last = '\0';
		}
        	res = lstat(work, &buf);
        	if (res == -1)
	 	{
           		return invalid_fh;
		}
        /* store 8 bit hash of the component's inode */
	        fh.inos[pos] = FH_HASH(buf.st_ino);
        	pos++;
        }while (last && pos < FH_MAXLEN);
	if(last)
	{
		return invalid_fh;
	} 
	fh.len = pos;
	fh.pwhash = export_password_hash;
	return fh;			
} 
