#include<sys/types.h> 

typedef struct XDR XDR;
typedef int bool_t;


struct xdr_ops
{
	bool_t (*x_getlong) (XDR *__xdrs, long *__lp);
	/* get a long from underlying stream */
	bool_t (*x_putlong) (XDR *__xdrs, long *__lp);
	 /* put a long to " */
	 bool_t (*x_getbytes) (XDR *__xdrs, caddr_t __addr, u_int __len);
	 /* get some bytes from " */
	 bool_t (*x_putbytes) (XDR *__xdrs, char *__addr, u_int __len);
	/* put some bytes to " */
	u_int (*x_getpostn) (XDR *__xdrs);
	/* returns bytes off from beginning */
	 bool_t (*x_setpostn) (XDR *__xdrs, u_int __pos);
};


struct XDR
{
	struct xdr_ops * x_ops;
	caddr_t x_public;           /* users' data */
	caddr_t x_private;          /* pointer to private data */
	caddr_t x_base;             /* private used for position info */
	u_int x_handy;              /* extra private word */
};
