

typedef bool_t (*xdrproc_t) (XDR *, void *,...);

enum xprt_stat {
        XPRT_DIED,
        XPRT_MOREREQS,
        XPRT_IDLE
};

struct xprtOps;


struct SVCXPRT {
	int xp_sock;
	u_short xp_port;
	struct xprtOps *xp_ops;
	int           xp_addrlen;      /* length of remote address */
	struct sockaddr_in xp_raddr;   /* remote address */
	struct opaque_auth xp_verf;    /* raw response verifier */ 
	caddr_t               xp_p1;           /* private */
	caddr_t               xp_p2;           /* private */
	char          xp_pad [256];   /* padding, internal use */
};

#define su_data(xprt)   ((struct svcudp_data *)(xprt->xp_p2))

struct xprtOps
{
	bool_t      (*xp_recv) (struct SVCXPRT *, struct rpc_msg *);
	       /* receive incoming requests */
	enum xprt_stat (*xp_stat) (struct SVCXPRT *);
		 /* get transport status */
	bool_t      (*xp_getargs) (struct SVCXPRT *, xdrproc_t , caddr_t ); 	
		 /* get arguments */
	bool_t      (*xp_reply) (struct SVCXPRT *, struct rpc_msg *);
		/* send reply */
	bool_t      (*xp_freeargs)(struct SVCXPRT *, xdrproc_t,  caddr_t);	
		 /* free mem allocated for args */
	 void        (*xp_destroy) (struct SVCXPRT *);
		 /* destroy this struct */
};


